/**
 ** p3dCntrlTaskCodels.c
 **
 ** Codels used by the control task p3dCntrlTask
 **
 ** Auteur: 
 ** Date: 
 **
 **/

/* #ifndef UNIX */
/* #include <vxWorks.h> */
/* #else */
#include <portLib.h>
/* #endif */
#include <stdio.h>
#include "server/p3dHeader.h"

/*
 * p3dAddWayPointCntrl --------------------------------------------------
 * control codel of CONTROL request AddWayPoint
 *
 * Description:    
 * Report (bilan): OK 
 *                 S_p3dCntrlTask_ETOOMANY
 *
 * Return:    OK ou ERROR
 */

STATUS
p3dAddWayPointCntrl(P3DWayPoint *wpP, int *bilan)
{
   if (SDI_F->wpList.number >= P3D_MAX_WAYPOINTS) {
      *bilan = S_p3d_ETOOMANY;
      return ERROR;
   }

   SDI_F->wpList.wps[SDI_F->wpList.number++] = *wpP;
   return OK;
}


/*
 * p3dClearWayPointsCntrl -----------------------------------------------
 * control codel of CONTROL request ClearWayPoints
 *
 * Description:    
 * Report (bilan): OK 
 *
 * Return:    OK ou ERROR
 */

STATUS
p3dClearWayPointsCntrl(int *bilan)
{
   SDI_F->wpList.number = 0;   
   return OK;
}

/*------------------------------------------------------------------------
 * p3dSetGoalParamsCntrl  -  control codel of CONTROL request SetGoalParams
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
p3dSetGoalParamsCntrl(P3DPlanParams *planP, int *report)
{
  if (planP->thetaUTurnHi < planP->thetaUTurnLow)
  {
      *report = S_p3d_HILO_ORDER;
      return ERROR;
  }
  return OK;
}

/*
 * p3dClearCurrentWayPointCntrl -----------------------------------------
 * control codel of CONTROL request ClearCurrentWayPoints
 *
 * Description:    
 * Report (bilan): OK 
 *
 * Return:    OK ou ERROR
 */

STATUS
p3dClearCurrentWayPointCntrl(int *bilan)
{
   int i;

   if (SDI_F->wpList.number > 0) {
      SDI_F->wpList.number--;
      for(i=1; i<P3D_MAX_WAYPOINTS; i++)
	 SDI_F->wpList.wps[i-1] = SDI_F->wpList.wps[i];
   }

   return OK;
}



/*
 *   
 */


extern STATUS p3dGoToCntrl(P3DWayPoint *(wpP), int *bilan)
{
  return OK;
}


extern STATUS p3dSetGoalDistBoundCntrl(P3DGoalDistance *(goalDistBound), int *bilan)
{
  if ( goalDistBound->distance < 0)
    return ERROR;
  return OK;
}

STATUS 
p3dSetDumpParamsCntrl(P3D_DUMP_PARAMS *dumpParams, int *bilan)
{
	return OK;
}
